import { IRepeaterConfig, RepeaterTaskFunction, TaskName, TaskPayload } from './types';
export declare const TASKMASTER_TASKS = "__taskmaster_tasks";
export declare const TASKMASTER_INSTANCE_PROP = "__taskmaster_instance";
export declare function getRepeaterInstance(object: any): RepeaterInstance;
export declare function getRepeaterTasks(object: any): Record<TaskName, {
    function: RepeaterTaskFunction;
    interval?: number;
    payload?: TaskPayload;
}>;
export declare class RepeaterInstance {
    private heartbeatInterval;
    private tasks;
    private isBusy;
    private intervalId;
    private errorCatcher;
    private origin;
    constructor(data: IRepeaterConfig);
    setOrigin(origin: any): void;
    start(): void;
    stop(): void;
    addTask(name: TaskName, task: RepeaterTaskFunction, interval?: number, payload?: TaskPayload): this;
    private processTasks;
}
