"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
function delay(duration) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise(resolve => setTimeout(resolve, duration));
    });
}
exports.delay = delay;
function throttler(interval, fn, fnName, errorCatcher) {
    let then;
    let isRunning = false;
    return (...args) => __awaiter(this, void 0, void 0, function* () {
        if (isRunning) {
            return;
        }
        const now = Date.now();
        if (then && !(now - then > interval)) {
            return;
        }
        then = now;
        isRunning = true;
        try {
            yield fn(...args);
        }
        catch (error) {
            yield errorCatcher(error, fnName, args);
        }
        isRunning = false;
    });
}
exports.throttler = throttler;
//# sourceMappingURL=utils.js.map